#include "stdafx.h"
#include "Saver.h"
#include "haiku.h"
#pragma hdrstop
#include <stdlib.h>
#include <stdio.h> 
#include <string.h> 
#include <time.h>

#define DICT_SIZE 8000
#define MAX_WORD 30

/*
int load_a_wordlist(char *fname, int *numwords, char *wordstr)
{
   FILE *tempfile;
   unsigned int x;
   
   if ((tempfile = fopen(fname, "rt")) == NULL)
	   return 1;
   fgets(wordstr, DICT_SIZE, tempfile);
   *numwords = 0;
   for (x = 0; x < strlen(wordstr); x++)
   	   if (wordstr[x] == ' ')
		   (*numwords)++;
   fclose(tempfile);
   return 0;
}

int load_dicts()
{
	int tempres;	
	tempres = load_a_wordlist("c:/werdlist/nouns", &nounwords, nouns);
	tempres += load_a_wordlist("c:/werdlist/possessives", &possessivewords, possessives);
	tempres += load_a_wordlist("c:/werdlist/articles", &articlewords, articles);
	tempres += load_a_wordlist("c:/werdlist/verbs", &verbwords, verbs);
	tempres += load_a_wordlist("c:/werdlist/prepositions", &prepositionwords, prepositions);
	tempres += load_a_wordlist("c:/werdlist/modifiers", &modifierwords, modifiers);
	return tempres;
}
*/
int CDictlist::syllableCount(CString *word, CString vowels)
{
   int x;
   int syllables = 0;
   int lastresult = 5000;
   /* below counts syllables by vowels, except when the occur next to each
other  */
   for (x = 0; x < ( word->GetLength()); x++) 
   {
      if ((vowels.Find(word->GetAt(x))) != NULL)
	  {
		  if (lastresult != (x-1)) /* don't count doubles */
		      syllables++;
		lastresult = x;
	  }
   }
   if (word->GetAt(word->GetLength()-1) == 'e') 
	   syllables--;
   /* missing a rule in here...fix */
   if (syllables == 0) 
	   syllables = 1;
   return syllables;
}
/*
char *getfromlist(unsigned int wordnum, char *wordlist)
{
	unsigned int x, y,curword = 0;
	for (x = 0; x < strlen(wordlist);x++)
	{
		if (wordlist[x] == ' ')
			curword++;
		if (curword == wordnum)
            for (y = (x+1); y < strlen(wordlist);y++)
				if (wordlist[y] == ' ')
		{
			if (wordlist[x] == ' ') x++; /* elminate space 
			strncpy(wordbuf, &wordlist[x], y-x);
			wordbuf[y-x] = (char) 0;
			return wordbuf;
		}
	}
	return (char *) NULL;
}
*/
CDictlist::CDictlist()
{
}

CDictlist::CDictlist(CString dictname) : CStringArray()
{
	FILE *wordfile;
	char tempword[50];
	if ((wordfile = fopen(dictname, "rt")) != NULL)
		{
		while (!(fgets(tempword, 50, wordfile) == NULL))
		{
			if (tempword[strlen(tempword)-1] <= 20)
				tempword[strlen(tempword)-1] = 0;
				tempword[strlen(tempword)+1] = 0;
				tempword[strlen(tempword)] = ' ';
			Add(tempword);
		}
		fclose(wordfile);
	}
}

/* CDictlist::~CDictlist()
{
} */

CHaiku::CHaiku() : CObject()
{
	m_articles = new CDictlist("c:\\werdlist\\articles");
	m_verbs = new CDictlist("c:\\werdlist\\verbs");
	m_possessives = new CDictlist("c:\\werdlist\\possessives");
	m_prepositions = new CDictlist("c:\\werdlist\\prepositions");
	m_nouns = new CDictlist("c:\\werdlist\\nouns");
	m_modifiers = new CDictlist("c:\\werdlist\\modifiers");
	CString* pStructure5 = new CString("nvnonr");
	m_structure5 = pStructure5;
		m_vowels = new CString("aeiouy");
	// m_structure5 = new pStructure5 = new ("nvnonr");
	m_structure7 = new CString("anvrmnmnr");
	m_line1 = new CString();
	m_line2 = new CString();
	m_line3 = new CString();
}

CHaiku::~CHaiku()
{
	delete m_articles;
	delete m_verbs;
	delete m_possessives;
	delete m_prepositions;
	delete m_nouns;
	delete m_modifiers;
	delete m_structure5;
	delete m_vowels;
	delete m_structure7;
}

CString* CDictlist::Getrandword(int maxsylls, int *cursylls, CString* vowels, CString* wordbuf)
{
	static CString curword;
	int numloops;
	if (maxsylls > 0)
		for (numloops = 1; numloops < 1000; numloops++)
		{
			curword = GetAt( rand() % (GetSize()) );
			if ((syllableCount(&curword,*vowels ))< maxsylls)
			{
				*cursylls = *cursylls + syllableCount(&curword, *vowels);
				*wordbuf += curword;
			    return &curword;
			}
	}
		// handle this better...
	return NULL;
}

CString* CHaiku::sentence(CString* format, unsigned int sylls)
{
	m_sy_total = 0;
	int x;
	static CString wordbuf;
	wordbuf = "";
    for(x = 0; x < format->GetLength(); x++)
	{
		switch(format->GetAt(x))
		{
			case 'n': ((m_nouns->Getrandword(sylls - m_sy_total, &m_sy_total,m_vowels, &wordbuf))); break;
			case 'v': ((m_verbs->Getrandword(sylls - m_sy_total, &m_sy_total,m_vowels, &wordbuf))); break;
			case 'o': ((m_possessives->Getrandword(sylls - m_sy_total, &m_sy_total,m_vowels, &wordbuf))); break;
			case 'r': ((m_prepositions->Getrandword(sylls - m_sy_total, &m_sy_total,m_vowels, &wordbuf))); break;
			case 'm': ((m_modifiers->Getrandword(sylls - m_sy_total, &m_sy_total,m_vowels, &wordbuf))); break;
			case 'a': ((m_articles->Getrandword(sylls - m_sy_total, &m_sy_total,m_vowels, &wordbuf))); break;
		}
	}
	// wordbuf += "/r";
	return &wordbuf;
}



CString*  CHaiku::makehaiku()
{   
	 static CString outstr;
	  outstr = "";
	  *m_line1 = *(sentence(m_structure5, 5));
	  *m_line2 = *(sentence(m_structure7, 7));
	  *m_line3 = *(sentence(m_structure5, 5));
	return &outstr;
}

/* main()
{
	srand( (unsigned)time( NULL ) );
	load_dicts();
	while (getch() != 'q')
	{
	sentence(STRUCTURE5, 5);
	sentence(STRUCTURE7, 7);
	sentence(STRUCTURE5, 5);
	}
	return 0;
}
*/